#if !defined  HAVE_NEGBIN_H__
#define       HAVE_NEGBIN_H__

#include "fxttypes.h"
#include "bits/bitsperlong.h"

#if  BITS_PER_LONG >= 64
#define MASK 0xaaaaaaaaaaaaaaaaUL
#else
#define MASK 0xaaaaaaaaUL
#endif

inline ulong bin2neg(ulong x)
// binary --> radix(-2)
//.
// hakmem, item 128
{
    ulong m = MASK;
    x += m;
    x ^= m;
    return  x;
}
// -------------------------

inline ulong neg2bin(ulong x)
// radix(-2) --> binary
// inverse of bin2neg()
{
    ulong m = MASK;
    x ^= m;
    x -= m;
    return  x;
}
// -------------------------

#undef MASK

inline ulong negbin_fixed_point(ulong k)
// Return the k-th (0<=k) fixed point of bin2neg()
// With k=ABCDEF (binary) the returned value is A0B0C0D0E0F.
{
    ulong f = 0;
    for (ulong m=1, s=0;  m!=0;  m<<=1, ++s)  f ^= ( (k&m)<<s );
    return  f;
}
// -------------------------

#endif  // !defined HAVE_NEGBIN_H__
