#if !defined  HAVE_ISQRT_H__
#define       HAVE_ISQRT_H__

#include <cmath> // ceil()


//#define  ISQRT_DEBUG
#ifdef ISQRT_DEBUG
#warning '***** ISQRT_DEBUG'
#include "jjassert.h"
#endif


template <typename Type>
Type isqrt(Type d)
// Return x (the integer quare root of d) so that
//  x*x <= d and  (x+1)*(x+1) > d
//.
// see Cohen p.38
{
    Type x = (Type)ceil(sqrt((double)d));
//    Type x = 1;
//    for (Type dd=d;  0!=dd;  dd>>=2)  x <<= 1;

    Type y = (x + d/x)/2;
    while ( y<x )
    {
        x = y;
        y = (x + d/x)/2;
    }

#ifdef ISQRT_DEBUG
    jjassert( x*x <= d );
    jjassert( (x+1)*(x+1) > d );
#endif

    return  x;
}
// -------------------------

#endif  // !defined HAVE_ISQRT_H__
