#if !defined HAVE_ROTATE_H__
#define      HAVE_ROTATE_H__


#include "fxttypes.h"
#include "perm/reverse.h"

template <typename Type>
void rotate_left(Type *f, ulong n, ulong s)
// Rotate towards element #0
// Shift is taken modulo n
{
    if ( s==0 )  return;
    if ( s>=n )
    {
        if ( n<2 ) return;
        s %= n;
    }

    reverse(f,   s);
    reverse(f+s, n-s);
    reverse(f,   n);
}
// -------------------------


template <typename Type>
void rotate_right(Type *f, ulong n, ulong s)
// Rotate away from element #0
// Shift is taken modulo n
{
    if ( s==0 )  return;
    if ( s>=n )
    {
        if ( n<2 ) return;
        s %= n;
    }

    reverse(f,     n-s);
    reverse(f+n-s, s);
    reverse(f,     n);
}
// -------------------------


template <typename Type>
void rotate_sgn(Type *f, ulong n, long s)
// Positive s --> shift away from element zero
{
    if ( s>0 )  rotate_right(f, n, (ulong)s);
    else        rotate_left(f, n, (ulong)-s);
}
// -------------------------


#endif // !defined HAVE_ROTATE_H__
